/****************************************************************************/
/*          Simple note-track player 1.0 - Canon Camera version             */
/****************************************************************************/
/* Created: 15.6.2005 [BORLAND C 4.52]                                      */
/* Last modified: 31.7.2005 [BORLAND C 4.52]                                */
/* Copyright (C) 2005 by RayeR                                              */
/* Contact: http://www.volny.cz/rayer                                       */
/* Compiler: Borland C++ 4.52, disable Word Alignment, use 80186 instr. set */
/****************************************************************************/
#define CAMERA_A70                     // set camera type for PSIOLib (keys defs) also A40,IXUSV
#include "psiolib.c"                   // PowerShot I/O library 2.4+

char fullpath2ini[64];                 // full path to noteplay .INI file
char fullpath2music[64]="a-ha.txt";    // full path to note track file
int tempo=2500;                        // default tempo in [ms] of 1/1 note
int pause=64;                          // pause between notes (tempo/pause [ms])
FILE *f;

//**************** read and play one note from text file *********************
void read_play_note(FILE *f, int printline)
{
  char note_s[8];                      // note string
  char c;
  int i=0,d1=0,d2=0;
  do {
    c=fgetc(f);                        // read a char from file
    if (c==EOF)                        // stop at EOF
      return;
    if (c=='#')                        // skip comment line beginning with #
      do {
        c=fgetc(f);                    // (read until EOF or EOL)
        } while ((c!=EOF)&&(c!=0x0A));
    if (c>47)                          // process only alphanumeric chars
      {
      note_s[i]=c;                     // put char into note string
      i++;
      }
    } while (c!='(');                  // loop until ( char readed
  note_s[i]=0;                         // terminate note string
  fscanf(f,"%d/%d)",&d1,&d2);          // read duration numbers
  if (printline>=0)
    {
    ps_gotoxy(0,printline);
    ps_clr_line(printline,15);         // clear line with black
    ps_printf(1,14,0,"current note: %s %d/%d",note_s,d1,d2); // print current note
    }
  if (stricmp(note_s,"C1")==0)         // notes string parser and play
    ps_sound(PS_NOTE_C1);
  if (stricmp(note_s,"D1")==0)
    ps_sound(PS_NOTE_D1);
  if (stricmp(note_s,"E1")==0)
    ps_sound(PS_NOTE_E1);
  if (stricmp(note_s,"F1")==0)
    ps_sound(PS_NOTE_F1);
  if (stricmp(note_s,"G1")==0)
    ps_sound(PS_NOTE_G1);
  if (stricmp(note_s,"A1")==0)
    ps_sound(PS_NOTE_A1);
  if (stricmp(note_s,"Ais1")==0)
    ps_sound(PS_NOTE_A1_);
  if (stricmp(note_s,"H1")==0)
    ps_sound(PS_NOTE_H1);
  if (stricmp(note_s,"C2")==0)
    ps_sound(PS_NOTE_C2);
  if (stricmp(note_s,"Cis2")==0)
    ps_sound(PS_NOTE_C2_);
  if (stricmp(note_s,"D2")==0)
    ps_sound(PS_NOTE_D2);
  if (stricmp(note_s,"Dis2")==0)
    ps_sound(PS_NOTE_D2_);
  if (stricmp(note_s,"E2")==0)
    ps_sound(PS_NOTE_E2);
  if (stricmp(note_s,"F2")==0)
    ps_sound(PS_NOTE_F2);
  if (stricmp(note_s,"Fis2")==0)
    ps_sound(PS_NOTE_F2_);
  if (stricmp(note_s,"G2")==0)
    ps_sound(PS_NOTE_G2);
  if (stricmp(note_s,"Gis2")==0)
    ps_sound(PS_NOTE_G2_);
  if (stricmp(note_s,"A2")==0)
    ps_sound(PS_NOTE_A2);
  if (stricmp(note_s,"Ais2")==0)
    ps_sound(PS_NOTE_A2_);
  if (stricmp(note_s,"H2")==0)
    ps_sound(PS_NOTE_H2);
  if (stricmp(note_s,"C3")==0)
    ps_sound(PS_NOTE_C3);
  if (stricmp(note_s,"Cis3")==0)
    ps_sound(PS_NOTE_C3_);
  if (stricmp(note_s,"D3")==0)
    ps_sound(PS_NOTE_D3);
  if (stricmp(note_s,"Dis3")==0)
    ps_sound(PS_NOTE_D3_);
  if (stricmp(note_s,"E3")==0)
    ps_sound(PS_NOTE_E3);
  if (stricmp(note_s,"F3")==0)
    ps_sound(PS_NOTE_F3);
  if (stricmp(note_s,"Fis3")==0)
    ps_sound(PS_NOTE_F3_);
  if (stricmp(note_s,"G3")==0)
    ps_sound(PS_NOTE_G3);
  if (stricmp(note_s,"Gis3")==0)
    ps_sound(PS_NOTE_G3_);
  if (stricmp(note_s,"A3")==0)
    ps_sound(PS_NOTE_A3);
  if (stricmp(note_s,"Ais3")==0)
    ps_sound(PS_NOTE_A3_);
  if (stricmp(note_s,"H3")==0)
    ps_sound(PS_NOTE_H3);
  ps_delay(tempo/d2);                  // keep sound for required time
  ps_nosound();                        // stop playing sound
  ps_delay(tempo/pause);               // a short pause between tones
}

//**************** load noteplay settings from given INI file, 1st line skipped
int load_config(char *p_path)
{
  FILE *f;
  if ((f=fopen(p_path,"r"))==NULL)     // open INI file in TEXT mode
    return(0);                         // if not exist defaults will be used
  while (getc(f)!='\n');               // skip 1st line
  fscanf(f,"music_file=%s",&fullpath2music); // read 2nd line
  while (getc(f)!='\n');               // skip trailing chars to EOL
  fscanf(f,"tempo=%d",&tempo);         // read 3rd line
  while (getc(f)!='\n');               // skip trailing chars to EOL
  fscanf(f,"pause=%d",&pause);         // read 4th line
  while (getc(f)!='\n');               // skip trailing chars to EOL
  fclose(f);
  return(1);
}

//**************** noteplay main ********************************************
int main(int argc, char *argv[])
{
  ps_init();
  ps_cls(15,0);                        // clear screen with 15=black
  memset(fullpath2ini,0,sizeof(fullpath2ini)); // clear the INI fullpath
  if (argc>0)                          // if 1 or more arguments forwarded
    memcpy(fullpath2ini,argv[0],strlen(argv[0])-3); // copy full path to called file (without EXE extension)
  strcat(fullpath2ini,"INI");          // append INI extension
  load_config(fullpath2ini);           // load noteplay setting from INI file
  ps_printf(0,14,0,"NotePlay 1.0 (C) 2005 by RayeR\n"); // line 0

  if ((f=fopen(fullpath2music,"r"))==NULL)
    {
    ps_printf(1,14,0,"no file:\n");    // line 1
    ps_printf(1,14,0,"%s",fullpath2music); // line 2
  	return(0);
    }
  else
    {
    ps_printf(1,14,0,"playing file:\n"); // line 1
    ps_printf(1,14,0,"%s",fullpath2music); // line 2
    }
  while (feof(f)==0)
    read_play_note(f,4);
  fclose(f);

  ps_gotoxy(0,6);
	ps_printf(1,14,0,"done...\n");
	ps_delay(1000);
	return(0);
}
